/* The game logic (no view code or direct user interaction) 
The game is a simple guess the word game based on mastermind*/

#pragma once

#include <string>
#include <vector>

// to make syntax Unreal friendly
using FString = std::string;   
using int32 = int;


struct FBullCowCount  
{
	int32 Bulls = 0;
	int32 Cows = 0;
};


enum class EGuessStatus 
{
	Invalid_Status,
	OK,
	Not_Isogram,
	Wrong_Length,
	Not_Lowercase
};


class FBullCowGame 
{
	// basically a contract. high level defining of what we want it to do without worrying about how it does it. 
public:
	FBullCowGame(); // constructor
	
	int32 GetMaxTries() const;   // getters should be constant as they retrive information, not manipulate
	int32 GetCurrentTry() const;
	int32 GetHiddenWordLength() const;
	bool IsGameWon() const;
	EGuessStatus CheckGuessValidity(FString Guess) const;

	void Reset();
	FBullCowCount SubmitValidGuess(FString Guess); // FBullCowCount is an example of a more rich return value, as it returns more than one value


private:
	// see constructor for intialisation 
	int32 MyCurrentTry;
	FString MyHiddenWord;
	bool bGameIsWon;

	bool IsIsogram(FString) const;
	bool IsLowercase(FString) const;
};